/* rygel-connection-manager.c generated by valac 0.14.1, the Vala compiler
 * generated from rygel-connection-manager.vala, do not modify */

/*
 * Copyright (C) 2008 OpenedHand Ltd.
 * Copyright (C) 2008 Zeeshan Ali <zeenix@gmail.com>.
 *
 * Author: Jorn Baayen <jorn@openedhand.com>
 *         Zeeshan Ali <zeenix@gmail.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <libgupnp/gupnp.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define RYGEL_TYPE_CONNECTION_MANAGER (rygel_connection_manager_get_type ())
#define RYGEL_CONNECTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CONNECTION_MANAGER, RygelConnectionManager))
#define RYGEL_CONNECTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_CONNECTION_MANAGER, RygelConnectionManagerClass))
#define RYGEL_IS_CONNECTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CONNECTION_MANAGER))
#define RYGEL_IS_CONNECTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_CONNECTION_MANAGER))
#define RYGEL_CONNECTION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_CONNECTION_MANAGER, RygelConnectionManagerClass))

typedef struct _RygelConnectionManager RygelConnectionManager;
typedef struct _RygelConnectionManagerClass RygelConnectionManagerClass;
typedef struct _RygelConnectionManagerPrivate RygelConnectionManagerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _RygelConnectionManager {
	GUPnPService parent_instance;
	RygelConnectionManagerPrivate * priv;
	gchar* sink_protocol_info;
	gchar* connection_ids;
	gchar* source_protocol_info;
	gint rcs_id;
	gint av_transport_id;
	gchar* direction;
};

struct _RygelConnectionManagerClass {
	GUPnPServiceClass parent_class;
};


static gpointer rygel_connection_manager_parent_class = NULL;

GType rygel_connection_manager_get_type (void) G_GNUC_CONST;
enum  {
	RYGEL_CONNECTION_MANAGER_DUMMY_PROPERTY
};
#define RYGEL_CONNECTION_MANAGER_UPNP_ID "urn:upnp-org:serviceId:ConnectionManager"
#define RYGEL_CONNECTION_MANAGER_UPNP_TYPE "urn:schemas-upnp-org:service:ConnectionManager:2"
#define RYGEL_CONNECTION_MANAGER_DESCRIPTION_PATH "xml/ConnectionManager.xml"
static void rygel_connection_manager_real_constructed (GObject* base);
static void rygel_connection_manager_query_source_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val);
static void _rygel_connection_manager_query_source_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self);
static void rygel_connection_manager_query_sink_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val);
static void _rygel_connection_manager_query_sink_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self);
static void rygel_connection_manager_query_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val);
static void _rygel_connection_manager_query_current_connection_ids_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self);
static void rygel_connection_manager_get_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action);
static void _rygel_connection_manager_get_protocol_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self);
static void rygel_connection_manager_get_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action);
static void _rygel_connection_manager_get_current_connection_ids_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self);
static void rygel_connection_manager_get_current_connection_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action);
static void _rygel_connection_manager_get_current_connection_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self);
RygelConnectionManager* rygel_connection_manager_new (void);
RygelConnectionManager* rygel_connection_manager_construct (GType object_type);
static void rygel_connection_manager_finalize (GObject* obj);


static void _rygel_connection_manager_query_source_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self) {
#line 50 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	rygel_connection_manager_query_source_protocol_info_cb (self, _sender, variable, value);
#line 95 "rygel-connection-manager.c"
}


static void _rygel_connection_manager_query_sink_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self) {
#line 52 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	rygel_connection_manager_query_sink_protocol_info_cb (self, _sender, variable, value);
#line 102 "rygel-connection-manager.c"
}


static void _rygel_connection_manager_query_current_connection_ids_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self) {
#line 54 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	rygel_connection_manager_query_current_connection_ids_cb (self, _sender, variable, value);
#line 109 "rygel-connection-manager.c"
}


static void _rygel_connection_manager_get_protocol_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self) {
#line 57 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	rygel_connection_manager_get_protocol_info_cb (self, _sender, action);
#line 116 "rygel-connection-manager.c"
}


static void _rygel_connection_manager_get_current_connection_ids_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self) {
#line 59 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	rygel_connection_manager_get_current_connection_ids_cb (self, _sender, action);
#line 123 "rygel-connection-manager.c"
}


static void _rygel_connection_manager_get_current_connection_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self) {
#line 61 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	rygel_connection_manager_get_current_connection_info_cb (self, _sender, action);
#line 130 "rygel-connection-manager.c"
}


static void rygel_connection_manager_real_constructed (GObject* base) {
	RygelConnectionManager * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 45 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	self = (RygelConnectionManager*) base;
#line 46 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp0_ = g_strdup ("");
#line 46 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_g_free0 (self->sink_protocol_info);
#line 46 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	self->sink_protocol_info = _tmp0_;
#line 47 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp1_ = g_strdup ("");
#line 47 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_g_free0 (self->source_protocol_info);
#line 47 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	self->source_protocol_info = _tmp1_;
#line 48 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp2_ = g_strdup ("0");
#line 48 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_g_free0 (self->connection_ids);
#line 48 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	self->connection_ids = _tmp2_;
#line 50 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::SourceProtocolInfo", (GCallback) _rygel_connection_manager_query_source_protocol_info_cb_gupnp_service_query_variable, self, 0);
#line 52 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::SinkProtocolInfo", (GCallback) _rygel_connection_manager_query_sink_protocol_info_cb_gupnp_service_query_variable, self, 0);
#line 54 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::CurrentConnectionIDs", (GCallback) _rygel_connection_manager_query_current_connection_ids_cb_gupnp_service_query_variable, self, 0);
#line 57 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetProtocolInfo", (GCallback) _rygel_connection_manager_get_protocol_info_cb_gupnp_service_action_invoked, self, 0);
#line 59 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetCurrentConnectionIDs", (GCallback) _rygel_connection_manager_get_current_connection_ids_cb_gupnp_service_action_invoked, self, 0);
#line 61 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetCurrentConnectionInfo", (GCallback) _rygel_connection_manager_get_current_connection_info_cb_gupnp_service_action_invoked, self, 0);
#line 171 "rygel-connection-manager.c"
}


static void rygel_connection_manager_query_source_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val) {
	const gchar* _tmp0_;
#line 65 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 65 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 65 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (var != NULL);
#line 65 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (val != NULL);
#line 68 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_value_init (val, G_TYPE_STRING);
#line 69 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp0_ = self->source_protocol_info;
#line 69 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_value_set_string (val, _tmp0_);
#line 191 "rygel-connection-manager.c"
}


static void rygel_connection_manager_query_sink_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val) {
	const gchar* _tmp0_;
#line 72 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 72 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 72 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (var != NULL);
#line 72 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (val != NULL);
#line 75 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_value_init (val, G_TYPE_STRING);
#line 76 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp0_ = self->sink_protocol_info;
#line 76 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_value_set_string (val, _tmp0_);
#line 211 "rygel-connection-manager.c"
}


static void rygel_connection_manager_query_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val) {
	const gchar* _tmp0_;
#line 79 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 79 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 79 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (var != NULL);
#line 79 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (val != NULL);
#line 82 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_value_init (val, G_TYPE_STRING);
#line 83 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp0_ = self->connection_ids;
#line 83 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_value_set_string (val, _tmp0_);
#line 231 "rygel-connection-manager.c"
}


static void rygel_connection_manager_get_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action) {
	GUPnPServiceAction* _tmp0_;
	guint _tmp1_ = 0U;
	GUPnPServiceAction* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GUPnPServiceAction* _tmp7_;
#line 86 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 86 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 86 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (action != NULL);
#line 88 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp0_ = action;
#line 88 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp1_ = gupnp_service_action_get_argument_count (_tmp0_);
#line 88 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	if (_tmp1_ != ((guint) 0)) {
#line 254 "rygel-connection-manager.c"
		GUPnPServiceAction* _tmp2_;
		const gchar* _tmp3_ = NULL;
#line 89 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_tmp2_ = action;
#line 89 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_tmp3_ = _ ("Invalid argument");
#line 89 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		gupnp_service_action_return_error (_tmp2_, (guint) 402, _tmp3_);
#line 91 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		return;
#line 265 "rygel-connection-manager.c"
	}
#line 94 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp4_ = action;
#line 94 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp5_ = self->source_protocol_info;
#line 94 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp6_ = self->sink_protocol_info;
#line 94 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	gupnp_service_action_set (_tmp4_, "Source", G_TYPE_STRING, _tmp5_, "Sink", G_TYPE_STRING, _tmp6_, NULL);
#line 97 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp7_ = action;
#line 97 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	gupnp_service_action_return (_tmp7_);
#line 279 "rygel-connection-manager.c"
}


static void rygel_connection_manager_get_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action) {
	GUPnPServiceAction* _tmp0_;
	guint _tmp1_ = 0U;
	GUPnPServiceAction* _tmp4_;
	const gchar* _tmp5_;
	GUPnPServiceAction* _tmp6_;
#line 100 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 100 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 100 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (action != NULL);
#line 102 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp0_ = action;
#line 102 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp1_ = gupnp_service_action_get_argument_count (_tmp0_);
#line 102 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	if (_tmp1_ != ((guint) 0)) {
#line 301 "rygel-connection-manager.c"
		GUPnPServiceAction* _tmp2_;
		const gchar* _tmp3_ = NULL;
#line 103 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_tmp2_ = action;
#line 103 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_tmp3_ = _ ("Invalid argument");
#line 103 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		gupnp_service_action_return_error (_tmp2_, (guint) 402, _tmp3_);
#line 105 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		return;
#line 312 "rygel-connection-manager.c"
	}
#line 108 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp4_ = action;
#line 108 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp5_ = self->connection_ids;
#line 108 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	gupnp_service_action_set (_tmp4_, "ConnectionIDs", G_TYPE_STRING, _tmp5_, NULL);
#line 110 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp6_ = action;
#line 110 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	gupnp_service_action_return (_tmp6_);
#line 324 "rygel-connection-manager.c"
}


static void rygel_connection_manager_get_current_connection_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action) {
	gchar* connection_id = NULL;
	GUPnPServiceAction* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean _tmp4_;
	GUPnPServiceAction* _tmp7_;
	guint _tmp8_ = 0U;
	GUPnPServiceAction* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	const gchar* _tmp14_;
	GUPnPServiceAction* _tmp15_;
#line 113 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 113 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 113 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	g_return_if_fail (action != NULL);
#line 117 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp0_ = action;
#line 117 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	gupnp_service_action_get (_tmp0_, "ConnectionID", G_TYPE_STRING, &connection_id, NULL);
#line 118 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp2_ = connection_id;
#line 118 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	if (_tmp2_ == NULL) {
#line 118 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_tmp1_ = TRUE;
#line 357 "rygel-connection-manager.c"
	} else {
		const gchar* _tmp3_;
#line 118 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_tmp3_ = connection_id;
#line 118 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "0") != 0;
#line 364 "rygel-connection-manager.c"
	}
#line 118 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp4_ = _tmp1_;
#line 118 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	if (_tmp4_) {
#line 370 "rygel-connection-manager.c"
		GUPnPServiceAction* _tmp5_;
		const gchar* _tmp6_ = NULL;
#line 119 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_tmp5_ = action;
#line 119 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_tmp6_ = _ ("Invalid connection reference");
#line 119 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		gupnp_service_action_return_error (_tmp5_, (guint) 706, _tmp6_);
#line 121 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_g_free0 (connection_id);
#line 121 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		return;
#line 383 "rygel-connection-manager.c"
	}
#line 124 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp7_ = action;
#line 124 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp8_ = gupnp_service_action_get_argument_count (_tmp7_);
#line 124 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	if (_tmp8_ != ((guint) 1)) {
#line 391 "rygel-connection-manager.c"
		GUPnPServiceAction* _tmp9_;
		const gchar* _tmp10_ = NULL;
#line 125 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_tmp9_ = action;
#line 125 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_tmp10_ = _ ("Invalid argument");
#line 125 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		gupnp_service_action_return_error (_tmp9_, (guint) 402, _tmp10_);
#line 127 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		_g_free0 (connection_id);
#line 127 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
		return;
#line 404 "rygel-connection-manager.c"
	}
#line 130 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp11_ = action;
#line 130 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp12_ = self->rcs_id;
#line 130 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp13_ = self->av_transport_id;
#line 130 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp14_ = self->direction;
#line 130 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	gupnp_service_action_set (_tmp11_, "RcsID", G_TYPE_INT, _tmp12_, "AVTransportID", G_TYPE_INT, _tmp13_, "ProtocolInfo", G_TYPE_STRING, "", "PeerConnectionManager", G_TYPE_STRING, "", "PeerConnectionID", G_TYPE_INT, -1, "Direction", G_TYPE_STRING, _tmp14_, "Status", G_TYPE_STRING, "OK", NULL);
#line 152 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_tmp15_ = action;
#line 152 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	gupnp_service_action_return (_tmp15_);
#line 113 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_g_free0 (connection_id);
#line 422 "rygel-connection-manager.c"
}


RygelConnectionManager* rygel_connection_manager_construct (GType object_type) {
	RygelConnectionManager * self = NULL;
#line 31 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	self = (RygelConnectionManager*) g_object_new (object_type, NULL);
#line 31 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	return self;
#line 432 "rygel-connection-manager.c"
}


RygelConnectionManager* rygel_connection_manager_new (void) {
#line 31 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	return rygel_connection_manager_construct (RYGEL_TYPE_CONNECTION_MANAGER);
#line 439 "rygel-connection-manager.c"
}


static void rygel_connection_manager_class_init (RygelConnectionManagerClass * klass) {
#line 31 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	rygel_connection_manager_parent_class = g_type_class_peek_parent (klass);
#line 31 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	G_OBJECT_CLASS (klass)->constructed = rygel_connection_manager_real_constructed;
#line 31 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_connection_manager_finalize;
#line 450 "rygel-connection-manager.c"
}


static void rygel_connection_manager_instance_init (RygelConnectionManager * self) {
}


static void rygel_connection_manager_finalize (GObject* obj) {
	RygelConnectionManager * self;
#line 31 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	self = RYGEL_CONNECTION_MANAGER (obj);
#line 37 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_g_free0 (self->sink_protocol_info);
#line 38 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_g_free0 (self->connection_ids);
#line 39 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_g_free0 (self->source_protocol_info);
#line 43 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	_g_free0 (self->direction);
#line 31 "/home/jens/Source/rygel/src/rygel/rygel-connection-manager.vala"
	G_OBJECT_CLASS (rygel_connection_manager_parent_class)->finalize (obj);
#line 472 "rygel-connection-manager.c"
}


/**
 * Basic implementation of UPnP ConnectionManager service version 2.
 */
GType rygel_connection_manager_get_type (void) {
	static volatile gsize rygel_connection_manager_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_connection_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelConnectionManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_connection_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelConnectionManager), 0, (GInstanceInitFunc) rygel_connection_manager_instance_init, NULL };
		GType rygel_connection_manager_type_id;
		rygel_connection_manager_type_id = g_type_register_static (GUPNP_TYPE_SERVICE, "RygelConnectionManager", &g_define_type_info, 0);
		g_once_init_leave (&rygel_connection_manager_type_id__volatile, rygel_connection_manager_type_id);
	}
	return rygel_connection_manager_type_id__volatile;
}



